#!/usr/bin/perl -I.
# Dreamcast Version
# SONIC ADVENTURE
# World Rankings Displayer
# 


use strict;
use CGI;
use DBI;

use	DC;
use POSIX	'strftime';

## Set up variables
use vars	(	'$dc',	# DC object
				'@IN',
				'$errorURL', '$cgiPath', 				
			);




##########################################################################################################################################
###################################################### CONFIGURATION SECTION	##########################################################
##########################################################################################################################################
##########################################################################################################################################

### VARIABLES FOR CONNECTING WITH YOUR AUTH DATABASE 
my $host="localhost";    
my $port=3306;    
my $user="root";    
my $pass="root"; 
my $db="dreamarena"; 
### END EDITABLE VARIABLES

my $dsn;
my $dsn_users;

$errorURL = "/home.html";
$cgiPath = "/cgi-bin/jetsetradio/login.cgi";
my $q = new CGI;
$dc = new DC($q);
$dc->q->import_names('IN');

#Extract basic user info
#INPUT: String -  Username/Nick
#OUTPUT: Array - 0: md5 password, 1:email, 2:country
sub DataUserByUserName
{
	my $username = shift;	
	my @result;
	
	my $dsn ="dbi:mysql:$db:$host:$port";
	
	my $dbh = DBI->connect($dsn, $user, $pass); 
	if ($DBI::err)
    {	
		$dc->q->param('message', "Can't connect to Users Database Server");
		$dc->q->param('backURL', $errorURL);
		$dc->output_form("html/error.html");
		return (1,@result);
	}
	
    if (length($dbh)==0)
    {
		$dc->q->param('message', "Can't connect to Users Database Server");
		$dc->q->param('backURL', $errorURL);
		$dc->output_form("html/error.html");
		return (1,@result);
    }
    
	
    my $sql = "SELECT user_id,password,emailaddress,countryid,city,state FROM users WHERE username='$username'";	
    my $query = $dbh->prepare($sql);
	
    $query->execute(); 
    if ($DBI::err)
    {
        
        $query->finish();
        $dbh->disconnect();
		$dc->q->param('message', "Error retrieving user information");
		$dc->q->param('backURL', $errorURL);
		$dc->output_form("html/error.html");
		return (1,@result);	
    }
    if ($query->rows > 0)
	{	
		@result = $query->fetchrow_array();
		return (0,@result);
	}
	return (1,@result);
}



#########################################################################################################################
############################################################# MAIN ######################################################
#########################################################################################################################



	if (($IN::username eq "") || ($IN::password eq ""))
	{
		$dc->q->param('header', "ERROR");
		$dc->q->param('message', "You must introduce your credentials");		
		$dc->q->param('backURL', $errorURL);
		$dc->output_form("html/error.html");		
	}
	
	else
	{
		
		my ($error,@userdata) = DataUserByUserName($IN::username);			
		
		if ($error == 0)
		{			
			 if (scalar(@userdata) > 0)
			 {

				if (($IN::password) eq $userdata[1])
				{												
					
					$dc->q->param('userid', $userdata[0]."  ");
					$dc->q->param('username', $IN::username."  ");
					$dc->q->param('email', $userdata[2]."  ");
					$dc->q->param('city', $userdata[4]."  ");
					$dc->q->param('state', $userdata[5]."  ");
					$dc->q->param('country', $userdata[3]."  ");
					$dc->output_form("html/login_message.html");		
				}
				else
				{
					$dc->q->param('header', "ERROR");
					$dc->q->param('message', "Username or Password are incorrect!!");
					$dc->q->param('backURL', $errorURL);
					$dc->output_form("html/error.html");		
				}
			 }
			 else
			 {
					$dc->q->param('header', "ERROR");
					$dc->q->param('message', "Username or Password are incorrect!!");
					$dc->q->param('backURL', $errorURL);
					$dc->output_form("html/error.html");		
			 }
		}
		else
		{
			$dc->q->param('header', "ERROR");
			$dc->q->param('message', "Username or Password are incorrect!!");
			$dc->q->param('backURL', $errorURL);
			$dc->output_form("html/error.html");		
		}
						
	 }
