#!/usr/local/bin/perl -I.

#use strict;

use CGI;
use POSIX	qw(strftime ceil);

# Debugging Option
$debugPrint = 0;

# -----------------------------------------------------
# encryption table
@base64    = ('A','B','C','D','E','F','G','H','I','J',
              'K','L','M','N','O','P','Q','R','S','T',
              'U','V','W','X','Y','Z','a','b','c','d',
              'e','f','g','h','i','j','k','l','m','n',
              'o','p','q','r','s','t','u','v','w','x',
              'y','z','0','1','2','3','4','5','6','7',
              '8','9','+','/','=');

@dp_base64 = ('A','Z','O','L','Y','N','d','n','E','T',
              'm','P','6','c','i','3','S','z','e','9',
              'I','y','X','B','h','D','g','f','Q','q',
              '7','l','5','b','a','t','M','4','r','p',
              'K','J','j','8','C','u','s','x','R','F',
              '+','k','2','V','0','w','U','G','o','1',
              'v','W','H','/','=');

	# Variables
	$root = "/web/jetgrindradio.web/";
	$servername = "tmp";
	$path = $root.$servername;  # path
	$filename = "";
	$savedVMS = 0;
	$filesize;
	my ($title, $comment, $mailaddress);
	my ($vmsdata);
	my (%graffiti, @BINDATA);

	my $serverfilename = sprintf "%08d", $$;
	
	$iType = 0;			# No defined image type
	%vmuInfo;

	if ($debugPrint)
	{
		open (DEBUG, ">debug.txt");
	}

	# get post
	%toPrint = &read_post;

	while(($key, $value) = each %toPrint)
	{
		if ($debugPrint)
		{
			print DEBUG "Key = ".$key."\n";
		}

		# get Graffiti Title
		if ($key eq "title") {
			$value =~ s/[\n\r]//g;
			$title = $value;
		}

		# get Graffiti comment
		if ($key eq "comment") {
			$value =~ s/[\n\r]//g;
			$comment = $value;
		}

		# get Graffiti Creator's E-mail Address
		if ($key eq "mailaddress") {
			$value =~ s/[\n\r]//g;
			$mailaddress = $value;
		}

		if ($key eq "VMUDATA")
		{
			@vmuData = split(/&/, $value);

			foreach $tmpVar (@vmuData) {
				($key, $value) = split(/=/, $tmpVar, 2);
				$key =~ s/%([A-Fa-f0-9]{2})/pack("C",hex($1))/ge;
				$key =~ s/[\n\r]//g;
				$value =~ s/%([A-Fa-f0-9]{2})/pack("C",hex($1))/ge;
				if ($debugPrint)
				{
					print DEBUG "KEY: ".$key."  VALUE: ".$value."\n";
				}
				$vmuInfo{$key} = $value;
			}

			while(($key, $value) = each %vmuInfo)
			{
				# get file name
				if ($key eq "filename") {
					$filename = $value;
					if( $filename eq "JETGRIND_SMA" ){
						$iType = 1;
					}
					elsif( $filename eq "JETGRIND_LAR" ){
						$iType = 2;
					}
					elsif( $filename eq "JETGRIND_XLA" ){
						$iType = 3;
					}
				}

				# get file size
				if ($key eq "fs") {
					$filesize = $value;
				}

				# get binary data
				if ($key eq "tm")
				{
					my ($trim, $base64, $binary);
					$trim = substr($value, 15);
					$base64 = "";
					$base64 = &decode_dp_base64($trim);
					if ($debugPrint) {
						print DEBUG "BASE 64 ENCODED BEGIN---------------------------------\n";
						print DEBUG $base64;
						print DEBUG "BASE 64 ENCODED END-----------------------------------\n";	
					}

					# Save the newly decoded data into the global array
					@BINDATA = &decode_base64($base64);
					if ($debugPrint)
					{
						# Dump the new binary data (testing only)
#						&bindump(\@BINDATA);
					}

                    # VMU Data was found and decoded
                    $savedVMS = 1;
				}
			}
		}
	}

    if ($savedVMS)
    {
        # create VMI datafile
        my $newname = "";
        my $vmidata;

		# Code erases the CRC value from the file
		$BINDATA[0x46] = 0;
		$BINDATA[0x47] = 0;
	
		%graffiti = &vmfile_graffiti(\@BINDATA);
	
		# Change directory
		if (chdir($path) == 0)
		{
			# CHECK THIS - ARE THE PERMISSIONS RIGHT??
			if ($debugPrint)
			{
#				print DEBUG "Directory does not exist - creating directory";
			}
			mkdir($path,0777);
		}
		
		# Set up the fields, if no fields are given use the defaults.
		# Users Graffiti Title
		if (length($title) != 0)
		{
			$graffiti{'title'} = $title;
			$graffiti{'titleSize'} = length($title);
		}
	
		# Users Graffiti Comment
		if (length($comment) != 0)
		{
			$graffiti{'comment'} = $comment;
			$graffiti{'commentSize'} = length($comment);
		}
	
		# Users Mailing Address
		if (length($mailaddress) != 0)
		{
			$graffiti{'mail'} = $mailaddress;
			$graffiti{'mailSize'} = length($mailaddress);
		}
	
		$vmsdata = make_vmfile_graffiti( \%graffiti );
	
		# Save JPG image
		$result = open( JPGFILE, ">${path}/${serverfilename}.jpg" );
		if( $result )
		{
			print JPGFILE $graffiti{'image'};
			close( JPGFILE );
			chmod(0666,"${path}/${serverfilename}.jpg");
		}
		else
		{
			die ("Unable to save JPG file.");
		}
	
		# Save VMS file
		$result = open (VMSFILE, ">${path}/${serverfilename}.VMS");
		if( $result )
		{
			print VMSFILE $vmsdata;
			close (VMSFILE);
			chmod(0666,"${path}/${serverfilename}.VMS");
		}
		else
		{
			die ("Unable to save VMS file.");
		}

        # Make First VMI File
		if ($iType == 1)
		{
			$newname = "JETGRIND_S00";
		}
		elsif ($iType == 2)
		{
			$newname = "JETGRIND_L00";
		}
		elsif ($iType == 3)
		{
			$newname = "JETGRIND_X00";
		}
		else
		{
			die ("Improper Filename has been used, and can't be saved");
		}

        $vmidata = make_vmidata($serverfilename, length($vmsdata), $newname);
        $result = open (VMIFILE, ">${path}/${serverfilename}.VMI");
		if( $result )
		{
			print VMIFILE $vmidata;
			close (VMIFILE);
			chmod(0666,"${path}/${serverfilename}.VMI");
		}
		else
		{
			die ("Unable to save VMI file.");
		}

		##############################################################
		# data structure display begins
	
		print &html_head("html");
		print "<HTML><HEAD>
		<TITLE>Data Dump</TITLE>
		<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">
		</HEAD><BODY>";
		
		print "<H1>JET GRIND RADIO IMAGE</H1>\n";
	
		print "VMU Size: ".length($vmsdata)." bytes, ".(length($vmsdata)/512)." blocks.<BR><BR>";
		print "Image Title: ".$graffiti{'title'}."<BR>";
		print "Image Comment: ".$graffiti{'comment'}."<BR>";
		print "User's Email: ".$graffiti{'mail'}."<BR>";
		print "<img src=\"/tmp/${serverfilename}.jpg\" border=0><BR>\n";
		print "\n<HR>";
		print "<P>Image Title Size: ".$graffiti{'titleSize'}."<BR>";
		print "<P>Image Comment Size: ".$graffiti{'commentSize'}."<BR>";
		print "<P>User's Email Size: ".$graffiti{'mailSize'}."<BR>";
	
		print "\n<HR>";

        print "<H2>Download Graffiti Tag:</H2>\n";
        print "<A HREF=\"http://jetgrindradio.web.dreamcast.com/${servername}/${serverfilename}.VMI\">Graffiti File</A><BR>\n";
    }

	if ($debugPrint)
	{
		print DEBUG "SERVER FILENAME: ".$serverfilename.".VMS\n";
		print DEBUG "PATH: ".$path."\n";
		close (DEBUG);
	}

	print "\n<HR>";
	print "<P><A HREF=\"/upload_graffiti.html\">Back</A></P>\n";
	print "</BODY></HTML>";

exit (0);

############################################################################
sub read_post {
	local($formData, $size, @returnData, %out, $tmpVar);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $formData = $ENV{'QUERY_STRING'};
    }
    elsif($ENV{'REQUEST_METHOD'} eq "POST") {
        $size = $ENV{'CONTENT_LENGTH'};
        read(STDIN, $formData, $size);
    }
    else
    {
        die "Problem figuring out GET or POST\n";
    }

	if ($debugPrint)
	{
		open (RAW, ">rawdata.txt");
		print RAW $formData."\n\n";
		close (RAW);
	}


    @boundry = split(/\s/, $formData);

    @returnData = split(/$boundry[0]([-]{0,2})/, $formData);
    foreach $tmpVar (@returnData) {
        $junk = "";
        $key = "";
        $value = "";

		if ($tmpVar ne "")
		{
			if ($tmpVar =~ /Content-Disposition: form-data; name=\"(.*)\"/)
			{
				$key = $1;
				($junk, $value) = split(/\".*\"/, $tmpVar, 2);
			}

			if ($key ne "")
			{
				if ($debugPrint)
				{
					print RAW "KEY: ".$key."  VALUE: ".$value."\n";
				}
				$out{$key} = $value;
			}
		}
	}

	if ($debugPrint)
	{
		close (RAW);
	}
    return %out;
}

############################################################################
sub	vmfile_graffiti{
	my $binary = shift;

	my( $lCurPos ) = 0;
	my( $loop );
	my( $cbTitle, $cbComment, $cbMailAddress, $cbAlphaImage, $cbImage );
	my( %data );
	
	for ($loop = 0; $loop < 0x280; $loop++)	{
		$data{'header'} .= pack("c", $binary->[$lCurPos + $loop]);
	}
	$lCurPos += 0x280;
	
	$cbTitle = $binary->[$lCurPos] | ($binary->[$lCurPos + 1] << 8) | ($binary->[$lCurPos + 2] << 16) | ($binary->[$lCurPos + 3] << 24);
	$data{'titleSize'} = $cbTitle;
	$lCurPos += 4;
	if( $cbTitle ){
		for ($loop = 0; $loop < $cbTitle; $loop++)	{
			$data{'title'} .= pack("c", $binary->[$lCurPos + $loop]);
		}
		$lCurPos += $cbTitle;
	}

	$cbComment = $binary->[$lCurPos] | ($binary->[$lCurPos + 1] << 8) | ($binary->[$lCurPos + 2] << 16) | ($binary->[$lCurPos + 3] << 24);
	$data{'commentSize'} = $cbComment;
	$lCurPos += 4;
	if( $cbComment ){
		for ($loop = 0; $loop < $cbComment; $loop++)	{
			$data{'comment'} .= pack("c", $binary->[$lCurPos + $loop]);
		}
		$lCurPos += $cbComment;
	}

	$cbMailAddress = $binary->[$lCurPos] | ($binary->[$lCurPos + 1] << 8) | ($binary->[$lCurPos + 2] << 16) | ($binary->[$lCurPos + 3] << 24);
	$data{'mailSize'} = $cbMailAddress;
	$lCurPos += 4;
	if( $cbMailAddress ){
		for ($loop = 0; $loop < $cbMailAddress; $loop++)	{
			$data{'mail'} .= pack("c", $binary->[$lCurPos + $loop]);
		}
		$lCurPos += $cbMailAddress;
	}

	$cbAlphaImage = $binary->[$lCurPos] | ($binary->[$lCurPos + 1] << 8) | ($binary->[$lCurPos + 2] << 16) | ($binary->[$lCurPos + 3] << 24);
	$data{'alphaSize'} = $cbAlphaImage;
	$lCurPos += 4;
	if( $cbAlphaImage ){
		for ($loop = 0; $loop < $cbAlphaImage; $loop++)	{
			$data{'alpha'} .= pack("c", $binary->[$lCurPos + $loop]);
		}
		$lCurPos += $cbAlphaImage;
	}

	$cbImage = $binary->[$lCurPos] | ($binary->[$lCurPos + 1] << 8) | ($binary->[$lCurPos + 2] << 16) | ($binary->[$lCurPos + 3] << 24);
	$data{'imageSize'} = $cbImage;
	$lCurPos += 4;
	if( $cbImage ){
		for ($loop = 0; $loop < $cbImage; $loop++)	{
			$data{'image'} .= pack("c", $binary->[$lCurPos + $loop]);
		}
	}

	return	%data;
}

############################################################################
sub	make_vmfile_graffiti{
	my $data  = shift;

	my( $binary, $number, $value, $clear, $left, $size );

	$binary = $data->{'header'};

	# Encode Title
	$number = $data->{'titleSize'};
	$number *= 2;
	$binary .= pack("C",($number & 0xFF));		# Convert number to 4 byte value
	$binary .= pack("C",(($number >> 8) & 0xFF));
	$binary .= pack("C",(($number >> 16) & 0xFF));
	$binary .= pack("C",(($number >> 24) & 0xFF));

	# Convert data into VMU compatible string
	foreach my $value(split(//,$data->{'title'}))
	{
		$binary .= pack("C",0x01);
		$binary .= $value;
	}

	# Encode Comment
	$number = $data->{'commentSize'};
	$number *= 2;
	$binary .= pack("C",($number & 0xFF));		# Convert number to 4 byte value
	$binary .= pack("C",(($number >> 8) & 0xFF));
	$binary .= pack("C",(($number >> 16) & 0xFF));
	$binary .= pack("C",(($number >> 24) & 0xFF));

	# Convert data into VMU compatible string
	foreach my $value(split(//,$data->{'comment'}))
	{
		$binary .= pack("C",0x01);
		$binary .= $value;
	}

	# Encode E-Mail Information
	$number = $data->{'mailSize'};
	$binary .= pack("C",($number & 0xFF));		# Convert number to 4 byte value
	$binary .= pack("C",(($number >> 8) & 0xFF));
	$binary .= pack("C",(($number >> 16) & 0xFF));
	$binary .= pack("C",(($number >> 24) & 0xFF));
	$binary .= $data->{'mail'};

	# Encode Alpha Channel Information
	$number = $data->{'alphaSize'};
	$binary .= pack("C",($number & 0xFF));		# Convert number to 4 byte value
	$binary .= pack("C",(($number >> 8) & 0xFF));
	$binary .= pack("C",(($number >> 16) & 0xFF));
	$binary .= pack("C",(($number >> 24) & 0xFF));
	$binary .= $data->{'alpha'};

	# Encode Image Information
	$number = $data->{'imageSize'};
	$binary .= pack("C",($number & 0xFF));		# Convert number to 4 byte value
	$binary .= pack("C",(($number >> 8) & 0xFF));
	$binary .= pack("C",(($number >> 16) & 0xFF));
	$binary .= pack("C",(($number >> 24) & 0xFF));
	$binary .= $data->{'image'};

	$size = ceil((length($binary) / 512.0)) * 512;
	$left = $size - length($binary);
	for ($clear = 0; $clear < $left; ++$clear)
	{
		$binary .= pack("C",0x00);
	}

	return	$binary;
}

############################################################################
sub html_head {
    local($type) = @_;
    return "Content-type: text/$type\n\n";
}

#############################################################################
# decode_dp_base64(<DP base 64'd data stream>)
# returns an array derived from DP base64 decoding the data stream.
#
# Argument: Character lines encoded by DP_BASE64.
# Back: Encoded bit character lines.
############################################################################
sub decode_dp_base64 {
	my $src = shift;
	my $bindata = ();
	my $i;

	my $count = 0;
	foreach my $c(split(//,$src))
	{
		if ($c eq '-') {
			last;
		}

		for ($i = 0; $i < 65; $i++)
		{
			if ($c eq $dp_base64[$i]) {
				$count++;
 				$bindata .= $base64[$i];
				if ($count == 77) {
					$count = 0;
					$bindata .= "\n";
				}
				last;
			}
		}
	}

	return $bindata;
}


############################################################################
# bindump(<binary data to dump>)
# Will dump out the data as an HTML file
############################################################################
sub bindump {
	my $binary = shift;
	my $max = $#{$binary} + 1;

	print &html_head("html");
	print "<HTML><HEAD><TITLE>Binary Dump</TITLE></HEAD><BODY>\n";
	print "<P>File Size:".$max."</P>\n";

	print "<TABLE BORDER=\"1\">\n";
	for (my $loop = 0; $loop < $max; $loop += 8)
	{
		print "<TR ALIGN=\"CENTER\" VALIGN=\"TOP\">";
		printf "<TD>%04X</TD>", $loop;
		printf "<TD>%02X</TD>", $binary->[$loop+0] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+1] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+2] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+3] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+4] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+5] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+6] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+7] & 0xFF;
		print "</TR>\n";
	}
	print "</TABLE>\n";
	print "</BODY></HTML>\n";
}

#############################################################################
# decode_base64(<base 64'd data stream>)
# returns an array derived from base64 decoding the data stream.
#
# Argument: Character lines encoded by BASE64.
# Back: Encoded bit character lines.
############################################################################
sub decode_base64 {
    my $src = shift;
 
    my @bindata = ();
    my $bytes =0;
    my $tmpstr = "";
    my $bits ="";
    foreach my $c (split(//,$src)) {
        if($c eq '=') {
            last;
        }
        if($c =~ /[A-Z]/) {
            $bits .= substr(unpack("B*",chr(ord($c)-ord('A'))),-6,6);
        } elsif($c =~ /[a-z]/) {
            $bits .= substr(unpack("B*",chr(ord($c)-ord('a')+26)),-6,6);
        } elsif($c =~ /[0-9]/) {
            $bits .= substr(unpack("B*",chr(ord($c)-ord('0')+52)),-6,6);
        } elsif($c  eq '+') {
            $bits .= substr(unpack("B*",chr(62)),-6,6);
        } elsif($c  eq '/') {
            $bits .= substr(unpack("B*",chr(63)),-6,6);
        }

		## now stuff it per-byte into @bindata
        if(length($bits) >= 8) {
            $bindata[$bytes++] = ord(pack("B*",substr($bits,0,8)));
            $bits = substr($bits,8,length($bits)-8);
        }
    }

    return @bindata;
}

############################################################################
# make_vmidata(<filename on server>, <filesize in bytes>, <filename on VMU>)
# Creating VMI data.  Filename and VMU filename should only be Uppercase.
# The filename does not require the .VMS extension.  It is assumed.
# returns a VMI data structure for the specified VMU file.
#
# Argument: Filename on server, filesize in bytes, and VMU filename.
# Back: VMI data file.
############################################################################
sub make_vmidata {
	my ($filename, $filesize, $vmufname) = @_;

	my ($i, @var, $FILE, @vmiheader);
	my @VMIDATA = ();

    @vmiheader = (
         "V", "M", "U", " ", "D", "O", "W", "N", "L", "O", "A", "D", " ", "F", "I", "L",
         "E","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0",
         "S", "E", "G", "A", " ", "E", "N", "T", "E", "R", "P", "R", "I", "S", "E", "S",
        "\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0"
        );

    for($i=0;$i<64;$i++) {
        $VMIDATA[$i+4] = ord($vmiheader[$i]);
    }

    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    $mon++;
    $VMIDATA[68]= ($year+1900 & 255);	# year (Low Byte)
    $VMIDATA[69]= ($year+1900 >> 8);	# year (High Byte)
    $VMIDATA[70]= $mon;			# month
    $VMIDATA[71]= $mday;		# day
    $VMIDATA[72]= $hour;		# hour
    $VMIDATA[73]= $min;			# minute
    $VMIDATA[74]= $sec;			# second
    $VMIDATA[75]= $wday;		# day of the week
    $VMIDATA[76]= 0;			# Version (inferior rank)
    $VMIDATA[77]= 1;			# Version (superior rank)
    $VMIDATA[78]= 1;			# # of files (inferior rank)
    $VMIDATA[79]= 0;			# # of files (superior rank)

    @var=split(//,$filename);
    for($i=0;$i<8;$i++) {
        $VMIDATA[$i+80] = ord($var[$i]);	# File names on server
    }

	$VMIDATA[0] = $VMIDATA[80] & 0x53;		# Checksum
	$VMIDATA[1] = $VMIDATA[81] & 0x45;		#
	$VMIDATA[2] = $VMIDATA[82] & 0x47;		#
	$VMIDATA[3] = $VMIDATA[83] & 0x41;		#

	$FILE = $vmufname;
    $FILE =~ y/a-z/A-Z/;

    @var=split(//,$FILE);
    for($i=0;$i<12;$i++) {
        $VMIDATA[$i+88] = ord($var[$i]);	# VMS file names
    }

	# Calculate Filesize
	$filesize = ($filesize / 512); # Convert to blocks

    $VMIDATA[100] = 0;			# Attributes
    $VMIDATA[101] = 0;			# Attributes
    $VMIDATA[102] = 0;			# Attributes
    $VMIDATA[103] = 0;			# Attributes
    $VMIDATA[104] = 0;			# File size
    $VMIDATA[105] = $filesize*2;	# File size
    $VMIDATA[106] = 0;			# File size
    $VMIDATA[107] = 0;			# File size

	my $vmidata = "";
	for($i=0;$i<108;$i++) {
        $vmidata .= pack("C",$VMIDATA[$i]);
    }

    return $vmidata;
}

#####################################################################
# BinaryToFloat()
# Input : An array of bytes that represent a floating point number.
# Output : The decimal value which is equivalent of the input float.
#####################################################################
sub BinaryToFloat()
{
        my $BinArr = shift;

        my($b0, $b1, $b2, $b3, $sign, $exponent, $non_exponent, $mult, $fraction, $pattern, $numerator, $bitset, @FractionBaseTable, $float, $x, $y, $z, $loop);

        my $str;

# Build the FractionBaseTable.
# It contains decreasing powers of 2 from 22 to 0.
        @FractionBaseTable = ();
        $FractionBaseTable[0] = 4194304;
        $FractionBaseTable[1] = 2097152;
        $FractionBaseTable[2] = 1048576;
        $FractionBaseTable[3] = 524288;
        $FractionBaseTable[4] = 262144;
        $FractionBaseTable[5] = 131072;
        $FractionBaseTable[6] = 65536;
        $FractionBaseTable[7] = 32768;
        $FractionBaseTable[8] = 16384;
        $FractionBaseTable[9] = 8192;
        $FractionBaseTable[10] = 4096;
        $FractionBaseTable[11] = 2048;
        $FractionBaseTable[12] = 1024;
        $FractionBaseTable[13] = 512;
        $FractionBaseTable[14] = 256;
        $FractionBaseTable[15] = 128;
        $FractionBaseTable[16] = 64;
        $FractionBaseTable[17] = 32;
        $FractionBaseTable[18] = 16;
        $FractionBaseTable[19] = 8;
        $FractionBaseTable[20] = 4;
        $FractionBaseTable[21] = 2;
        $FractionBaseTable[22] = 1;
        $FractionBaseTable[23] = 0;

#Read the 4 bytes
        $b0 = $BinArr->[0];
        $b1 = $BinArr->[1];
        $b2 = $BinArr->[2];
        $b3 = $BinArr->[3];

		# Check to see if everything is clear, then output zero
		if (($b0|$b1|$b2|$b3) == 0)	{
			return 0.0;
		}

# Take the sign bit : 7th bit of b3
        $sign = $b3 & 0x80;

# Calculate the exponent now.
        $x = ($b3 << 8) | $b2;
        $exponent = ($x >> 7) & 0xFF;
        $mult = $exponent - 127;

#Calculate the non-exponent component
        $y = ($b2 << 16) | ($b1 << 8) | $b0;
        $z = $y & 0x7FFFFF;
        $fraction = $z << 1;
        $pattern = $fraction;
        $numerator = 0;
        for ($loop = 0; $loop < 23; $loop++)    {
                $bitset = ($pattern & 0x800000);
                if ($bitset)    {
                        $numerator += $FractionBaseTable[$loop];
                }
                $pattern = $pattern << 1;
        }
        $non_exponent = ($numerator / 8388608) + 1.0;
        $float = ($non_exponent) * 2 ** $mult;
        if ($sign)      {
                $float *= (-1);
        }
        return $float;
}

#####################################################################
# CalcTime()
# Input : Time value
# Output : Minutes, seconds, miliseconds
#####################################################################
sub CalcTime()	{
	$time = shift;

	$time =~ s/\+//;
	$min = int($time / 10000 / 60);
	$sec = ($time / 10000) % 60;
	$msec = sprintf("%03d", ($time % 10000) / 10);
	$str = $min.":".$sec.".".$msec;
	return $str;
}
 

#####################################################################
# crcCalculateBuffer()
# Input : 
# Output : 
#####################################################################
sub crcCalculateBuffer()
{
	my $byteOffset = shift;
	my $nByteCount = shift;
	my $crcValue = shift;
	my $cBufferPtr = shift;
	my ($crc, $crcPolynomial, $crcData, $i, $j, @crcTable);

	$crcPolynomial = 0xEDB88320;
	@crcTable = ();
	for ($i = 0; $i < 256; $i++) {
		$crc = $i;
		for ($j = 0; $j < 8; $j++) {
			if ($crc & 0x0001) {
				$crc = ($crc >> 1) ^ $crcPolynomial;
			}
			else {
				$crc = $crc >> 1;
			}
		}
		$crcTable[$i] = $crc;
	}
	#Calculate the new CRC here :-
	$crc = $crcValue;
	for ($i = 0; $i < $nByteCount; $i++) {
		$crcData = ($crc ^ $cBufferPtr->[$byteOffset + $i]) & 0xFF;
		$crc = (($crc >> 8) & 0x00FFFFFF) ^ $crcTable[$crcData];
	}
	return $crc;
}
