#!/usr/local/bin/perl -I.

#Things to be done : Decode car key word. Print values.
#
# 32 Bit CRC is 0xAB15FC84
#

#use strict;

use CGI;
use POSIX	'strftime';

# Debugging Option
$debugPrint = 0;

# -----------------------------------------------------
# encryption table
@base64    = ('A','B','C','D','E','F','G','H','I','J',
              'K','L','M','N','O','P','Q','R','S','T',
              'U','V','W','X','Y','Z','a','b','c','d',
              'e','f','g','h','i','j','k','l','m','n',
              'o','p','q','r','s','t','u','v','w','x',
              'y','z','0','1','2','3','4','5','6','7',
              '8','9','+','/','=');

@dp_base64 = ('A','Z','O','L','Y','N','d','n','E','T',
              'm','P','6','c','i','3','S','z','e','9',
              'I','y','X','B','h','D','g','f','Q','q',
              '7','l','5','b','a','t','M','4','r','p',
              'K','J','j','8','C','u','s','x','R','F',
              '+','k','2','V','0','w','U','G','o','1',
              'v','W','H','/','=');

@Characters = (
				'Beat',
				'Gum',
				'Tab',
				'Combo',
				'Slate',
				'Piranha',
				'Cube',
				'Mew',
				'Yo-Yo',
				'Garam',
				'Love Shocker',
				'Poison Jam',
				'Noise Tanks',
				'Goji',
				'Pots',
				);

@Class = (
			'Pedal!',
			'Motor!',
			'Engine!',
			'Turbo!',
			'Nitro!',
			'Jet!',
		 );

@Stage = (
		  'Shibuya Story',
		  'Shibuya Jet Crush',
		  'Shibuya Jet Technique',
		  'Shibuya Jet Graffiti',

		  'Kogane Story',
		  'Kogane Jet Crush',
		  'Kogane Jet Technique',
		  'Kogane Jet Graffiti',

		  'Benten Story',
		  'Benten Jet Crush',
		  'Benten Jet Technique',
		  'Benten Jet Graffiti',

		  'Bantam Story',
		  'Benten Jet Crush',
		  'Benten Jet Technique',
		  'Benten Jet Graffiti',

		  'Grind Square Story',
		  'Grind Square Jet Crush',
		  'Grind Square Jet Technique',
		  'Grind Square Jet Graffiti',
		);

@StageName = ('Shibuya GG',
			  'Love Trap',
			  'Love Attack',
			  'Explosion',
			  '',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'The Monster of Kogane',
			  'No. 540',
			  'Kogane Circus',
			  'Fight or Flight',
			  '',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Benten Boogie',
			  'Graffiti High',
			  'Noise Reduction',
			  'Benten Burning',
			  'Behind the Mask',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Tag or Die',
			  '',
			  '',
			  '',
			  '',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',

			  'Rock\' N Roll Grind',
			  '',
			  '',
			  '',
			  '',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			  '1st','2nd','3rd','4th','5th',
			 );


	# Variables
	$filename = "";
	$savedVMS = 0;
	$filesize;
	$checksum;
	$user_id;
	$serverfilename;
	%vmuInfo;

	if ($debugPrint)
	{
		open (DEBUG, ">debug.txt");
	}

	# get post
	%toPrint = &read_post;

	while(($key, $value) = each %toPrint)
	{
		if ($debugPrint)
		{
			print DEBUG "Key = ".$key."\n";
		}

		# get user id
		if ($key eq "user_id") {
			$value =~ s/[\n\r]//g;
			$user_id = $value;
		}

		if ($key eq "VMUDATA")
		{
			@vmuData = split(/&/, $value);

			foreach $tmpVar (@vmuData) {
				($key, $value) = split(/=/, $tmpVar, 2);
				$key =~ s/%([A-Fa-f0-9]{2})/pack("C",hex($1))/ge;
				$key =~ s/[\n\r]//g;
				$value =~ s/%([A-Fa-f0-9]{2})/pack("C",hex($1))/ge;
				if ($debugPrint)
				{
					print DEBUG "KEY: ".$key."  VALUE: ".$value."\n";
				}
				$vmuInfo{$key} = $value;
			}

			while(($key, $value) = each %vmuInfo)
			{
				# get file name
				if ($key eq "filename") {
					$filename = $value;
				}

				# get file size
				if ($key eq "bl") {
					$filesize = $value;
				}

				# get binary data
				if ($key eq "tm")
				{
					my ($trim, $base64, @BINDATA, $binary);
					$trim = substr($value, 15);
					$base64 = "";
					$base64 = &decode_dp_base64($trim);
					if ($debugPrint) {
						print DEBUG "BASE 64 ENCODED BEGIN---------------------------------\n";
						print DEBUG $base64;
						print DEBUG "BASE 64 ENCODED END-----------------------------------\n";	
					}
					@BINDATA = &decode_base64($base64);

					&decode_jgrData(0x280, \@BINDATA);

					if ($debugPrint)	{
						for(my $i=0;$i<($#BINDATA + 1);$i++) {
							$binary .= pack("C",$BINDATA[$i]);
						}

						$serverfilename = sprintf "%08d", $$;

						# Save VMS file
						if (open (VMSFILE, ">${serverfilename}.VMS"))
						{
							print VMSFILE $binary;
							close (VMSFILE);
						}
						else
						{
							die "Unable to create VMU File.";
						}
					}

					##############################################################
					# shilpa data structure decode begin

					$offset = 0x280;

					if ($debugPrint)	{
						&bindump(\@BINDATA);
						exit (0);
					}

					$ptr = 0;
					$guid = $BINDATA[$offset + $ptr] | ($BINDATA[$offset + $ptr + 1] << 8) | ($BINDATA[$offset + $ptr + 2] << 16) | ($BINDATA[$offset + $ptr + 3] << 24);
					$ptr += 4;

					my @tempArr1 = ($BINDATA[$offset + $ptr], $BINDATA[$offset + $ptr + 1], $BINDATA[$offset + $ptr + 2], $BINDATA[$offset + $ptr + 3]);
					$volume = &BinaryToFloat(\@tempArr1);
					$ptr += 4;

					$gameclear = $BINDATA[$offset + $ptr] | ($BINDATA[$offset + $ptr + 1] << 8) | ($BINDATA[$offset + $ptr + 2] << 16) | ($BINDATA[$offset + $ptr + 3] << 24);
					$ptr += 4;

					for ($i = 0; $i < 20; $i++)
					{
						for ($j = 0; $j < 5; $j++)
						{
							$rank_point[$i][$j] = $BINDATA[$offset + $ptr] | ($BINDATA[$offset + $ptr + 1] << 8) | ($BINDATA[$offset + $ptr + 2] << 16) | ($BINDATA[$offset + $ptr + 3] << 24);
							$ptr += 4;
							if (($i == 1) || ($i == 5) || ($i == 9) || ($i == 13) || ($i == 17))
							{
								$rank_point[$i][$j] = $rank_point[$i][$j] / 100.0;
							}

							$rank_rank[$i][$j] = $BINDATA[$offset + $ptr];
							$ptr += 1;

							$rank_player[$i][$j] = $BINDATA[$offset + $ptr];
							$ptr += 1;

							# Possible Padding
							$ptr += 1;

							# Possible Padding
							$ptr += 1;
						}
					}

					###########################

					print &html_head("html");
					print "<HTML><HEAD><TITLE>Data Dump</TITLE></HEAD><BODY>";
	
					print "<H1>JET GRIND RADIO DATA START</H1>\n";
					print "<TABLE BORDER=0 cellspacing=1 cellpadding=0 width=580>\n";
					print "<TR><TD ALIGN=\"right\" WIDTH=\"250\">guid : </TD><TD>".$guid."</TD></TR>\n";
					print "<TR><TD ALIGN=\"right\" WIDTH=\"250\">Real guid : </TD><TD>".hex("018DA67F")."</TD></TR>\n";
					print "<TR><TD ALIGN=\"right\">volume : </TD><TD>".$volume."</TD></TR>\n";
					print "<TR><TD ALIGN=\"right\">gameclear : </TD><TD>".$gameclear."</TD></TR>\n";

					for ($i = 0; $i < 20; $i++)
					{
						print "<TR><TD ALIGN=\"left\" colspan=2><TABLE BORDER=1>\n";
						for ($j = 0; $j < 5; $j++)
						{
							print "<TR><TD ALIGN=\"left\">".$Stage[$i]."</TD><TD>".$StageName[($i*5)+$j]."</TD></TR>\n";
							if ($rank_point[$i][$j] > 0)
							{
								print "<TR><TD ALIGN=\"right\">Character : </TD><TD>".$Characters[$rank_player[$i][$j]]."</TD></TR>\n";
								print "<TR><TD ALIGN=\"right\">Rank : </TD><TD>".$Class[$rank_rank[$i][$j]]."</TD></TR>\n";
								print "<TR><TD ALIGN=\"right\">Points : </TD><TD>".$rank_point[$i][$j]."</TD></TR>\n";
							}
							else
							{
								print "<TR><TD ALIGN=\"center\" colspan=2>No Entry</TD></TR>\n";
							}
						}
						print "</TABLE><HR></TD></TR>\n";
					}


					print "</TABLE>\n";
				}
			}
		}
	}

	if ($debugPrint)
	{
		print DEBUG "SERVER FILENAME: ".$serverfilename.".VMS\n";
		print DEBUG "VMU FILENAME: ".$filename."\n";
		print DEBUG "FILESIZE: ".$filesize."\n";
		print DEBUG "CHECKSUM: ".$checksum."\n";
		print DEBUG "USER ID: ".$user_id."\n";
		print DEBUG "PATH: ".$path."\n";
		close (DEBUG);
	}

	print "\n<HR>";
	print "<P><A HREF=\"/index.html\">Back</A></P>\n";
	print "</BODY></HTML>";

exit (0);

############################################################################
sub read_post {
	local($formData, $size, @returnData, %out, $tmpVar);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $formData = $ENV{'QUERY_STRING'};
    }
    elsif($ENV{'REQUEST_METHOD'} eq "POST") {
        $size = $ENV{'CONTENT_LENGTH'};
        read(STDIN, $formData, $size);
    }
    else
    {
        die "Problem figuring out GET or POST\n";
    }

	if ($debugPrint)
	{
		open (RAW, ">rawdata.txt");
		print RAW $formData."\n\n";
		close (RAW);
	}


    @boundry = split(/\s/, $formData);

    @returnData = split(/$boundry[0]([-]{0,2})/, $formData);
    foreach $tmpVar (@returnData) {
        $junk = "";
        $key = "";
        $value = "";

		if ($tmpVar ne "")
		{
			if ($tmpVar =~ /Content-Disposition: form-data; name=\"(.*)\"/)
			{
				$key = $1;
				($junk, $value) = split(/\".*\"/, $tmpVar, 2);
			}

			if ($key ne "")
			{
				if ($debugPrint)
				{
					print RAW "KEY: ".$key."  VALUE: ".$value."\n";
				}
				$out{$key} = $value;
			}
		}
	}

	if ($debugPrint)
	{
		close (RAW);
	}
    return %out;
}

############################################################################
sub html_head {
    local($type) = @_;
    return "Content-type: text/$type\n\n";
}

#############################################################################
# decode_dp_base64(<DP base 64'd data stream>)
# returns an array derived from DP base64 decoding the data stream.
#
# Argument: Character lines encoded by DP_BASE64.
# Back: Encoded bit character lines.
############################################################################
sub decode_dp_base64 {
	my $src = shift;
	my $bindata = ();
	my $i;

	my $count = 0;
	foreach my $c(split(//,$src))
	{
		if ($c eq '-') {
			last;
		}

		for ($i = 0; $i < 65; $i++)
		{
			if ($c eq $dp_base64[$i]) {
				$count++;
 				$bindata .= $base64[$i];
				if ($count == 77) {
					$count = 0;
					$bindata .= "\n";
				}
				last;
			}
		}
	}

	return $bindata;
}


############################################################################
# bindump(<binary data to dump>)
# Will dump out the data as an HTML file
############################################################################
sub bindump {
	my $binary = shift;
	my $max = $#{$binary} + 1;

	print &html_head("html");
	print "<HTML><HEAD><TITLE>Binary Dump</TITLE></HEAD><BODY>\n";
	print "<P>File Size:".$max."</P>\n";

	print "<TABLE BORDER=\"1\">\n";
	for (my $loop = 0; $loop < $max; $loop += 8)
	{
		print "<TR ALIGN=\"CENTER\" VALIGN=\"TOP\">";
		printf "<TD>%04X</TD>", $loop;
		printf "<TD>%02X</TD>", $binary->[$loop+0] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+1] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+2] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+3] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+4] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+5] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+6] & 0xFF;
		printf "<TD>%02X</TD>", $binary->[$loop+7] & 0xFF;
		print "</TR>\n";
	}
	print "</TABLE>\n";
	print "</BODY></HTML>\n";
}

#############################################################################
# decode_base64(<base 64'd data stream>)
# returns an array derived from base64 decoding the data stream.
#
# Argument: Character lines encoded by BASE64.
# Back: Encoded bit character lines.
############################################################################
sub decode_base64 {
    my $src = shift;
 
    my @bindata = ();
    my $bytes =0;
    my $tmpstr = "";
    my $bits ="";
    foreach my $c (split(//,$src)) {
        if($c eq '=') {
            last;
        }
        if($c =~ /[A-Z]/) {
            $bits .= substr(unpack("B*",chr(ord($c)-ord('A'))),-6,6);
        } elsif($c =~ /[a-z]/) {
            $bits .= substr(unpack("B*",chr(ord($c)-ord('a')+26)),-6,6);
        } elsif($c =~ /[0-9]/) {
            $bits .= substr(unpack("B*",chr(ord($c)-ord('0')+52)),-6,6);
        } elsif($c  eq '+') {
            $bits .= substr(unpack("B*",chr(62)),-6,6);
        } elsif($c  eq '/') {
            $bits .= substr(unpack("B*",chr(63)),-6,6);
        }

		## now stuff it per-byte into @bindata
        if(length($bits) >= 8) {
            $bindata[$bytes++] = ord(pack("B*",substr($bits,0,8)));
            $bits = substr($bits,8,length($bits)-8);
        }
    }

    return @bindata;
}

#############################################################################
# decode_jgrData(<offset>, <binary data>)
# returns an binary array derived from JGR encoded the data stream.
#
# Argument: Binary data encoded by JGR.
# Back: Unencoded binary data.
############################################################################
sub decode_jgrData {
	my $offset = shift;
    my $bindata = shift;

	my @dk = ();
	my ($i, $j, $shift, $nk, $size);

	# Defined Values
	my $SAVELOAD_KEY_NUM = 8;
	my $SYSTEM_SAVE_DATA = 1008;

	# Size of the actual ranking data
	$size = ($SYSTEM_SAVE_DATA - $SAVELOAD_KEY_NUM);

	# Read the last eight bytes
	for ($i = 0; $i < $SAVELOAD_KEY_NUM; $i++)
	{
		$dk[$i] = $bindata->[$offset + $size + $i];
		if ($dk[$i] & 0x80)
		{
			# Turn it into a signed number
			$dk[$i] = sprintf "%d", $dk[$i] |= 0xFFFFFF00;
		}

		if ($dk[$i] == 0)
		{
			# An Error condition occurred.
			$bindata->[$offset + 0] = 0;
			$bindata->[$offset + 1] = 0;
			$bindata->[$offset + 2] = 0;
			$bindata->[$offset + 3] = 0;

			return;
		}
	}

	# Decode the binary data
	for ($i = $size - 1; $i >= 0; $i--)
	{
		$j = $i % $SAVELOAD_KEY_NUM;

		# 3bit Decoding
		$nk = ($dk[$j] >> 3) & 0x1f;
		$nk |= ($dk[$j] << 5) & 0xe0;
		if ($nk & 0x80)
		{
			# Turn it into a signed number
			$nk = sprintf "%d", $nk |= 0xFFFFFF00;
		}


		$dk[$j] = $nk;
		$shift = $i + $dk[$j];
		print $i.": ".$nk.", ".$shift.";";
		
		if ($shift < 0) {
			$shift += $size;
		}
		elsif ($shift >= $size) {
			$shift -= $size;
		}
		$nk = $bindata->[$offset + $i];
		$bindata->[$offset + $i] = $bindata->[$offset + $shift];
		$bindata->[$offset + $shift] = $nk ^ $bindata->[$offset + $i];
	}

    return;
}

############################################################################
# make_vmidata(<filename on server>, <filesize in bytes>, <filename on VMU>)
# Creating VMI data.
# returns an array derived from DP base64 decoding the data stream.
#
# Argument: Character lines encoded by DP_BASE64.
# Back: Encoded bit character lines.
############################################################################
sub make_vmidata {
	my ($filename, $filesize, $vmufname) = @_;

	my ($i, @var, $FILE, @vmiheader);
	my @VMIDATA = ();

    @vmiheader = (
         "V", "M", "U", " ", "D", "O", "W", "N", "L", "O", "A", "D", " ", "F", "I", "L",
         "E","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0",
         "S", "E", "G", "A", " ", "E", "N", "T", "E", "R", "P", "R", "I", "S", "E", "S",
        "\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0","\0"
        );

    for($i=0;$i<64;$i++) {
        $VMIDATA[$i+4] = ord($vmiheader[$i]);
    }

    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    $mon++;
    $VMIDATA[68]= ($year+1900 & 255);	# year (Low Byte)
    $VMIDATA[69]= ($year+1900 >> 8);	# year (High Byte)
    $VMIDATA[70]= $mon;			# month
    $VMIDATA[71]= $mday;		# day
    $VMIDATA[72]= $hour;		# hour
    $VMIDATA[73]= $min;			# minute
    $VMIDATA[74]= $sec;			# second
    $VMIDATA[75]= $wday;		# day of the week
    $VMIDATA[76]= 1;			# Version (superior rank)
    $VMIDATA[77]= 0;			# Version (inferior rank)
    $VMIDATA[78]= 1;			# # of files (inferior rank)
    $VMIDATA[79]= 0;			# # of files (superior rank)

    @var=split(//,$filename);
    for($i=0;$i<8;$i++) {
        $VMIDATA[$i+80] = ord($var[$i]);	# File names on server
    }

	$VMIDATA[0] = $VMIDATA[80] & 0x53;		# Checksum
	$VMIDATA[1] = $VMIDATA[81] & 0x45;		#
	$VMIDATA[2] = $VMIDATA[82] & 0x47;		#
	$VMIDATA[3] = $VMIDATA[83] & 0x41;		#

	$FILE = $vmufname;
    $FILE =~ y/a-z/A-Z/;

    @var=split(//,$FILE);
    for($i=0;$i<12;$i++) {
        $VMIDATA[$i+88] = ord($var[$i]);	# VMS file names
    }

    $VMIDATA[100] = 0;			# Attributes
    $VMIDATA[101] = 0;			# Attributes
    $VMIDATA[102] = 0;			# Attributes
    $VMIDATA[103] = 0;			# Attributes
    $VMIDATA[104] = 0;			# File size
    $VMIDATA[105] = $filesize*2;	# File size
    $VMIDATA[106] = 0;			# File size
    $VMIDATA[107] = 0;			# File size

	my $vmidata = "";
	for($i=0;$i<108;$i++) {
        $vmidata .= pack("C",$VMIDATA[$i]);
    }

    return $vmidata;
}


#####################################################################
# BinaryToFloat()
# Input : An array of bytes that represent a floating point number.
# Output : The decimal value which is equivalent of the input float.
#####################################################################
sub BinaryToFloat()
{
        my $BinArr = shift;

        my($b0, $b1, $b2, $b3, $sign, $exponent, $non_exponent, $mult, $fraction, $pattern, $numerator, $bitset, @FractionBaseTable, $float, $x, $y, $z, $loop);

        my $str;

# Build the FractionBaseTable.
# It contains decreasing powers of 2 from 22 to 0.
        @FractionBaseTable = ();
        $FractionBaseTable[0] = 4194304;
        $FractionBaseTable[1] = 2097152;
        $FractionBaseTable[2] = 1048576;
        $FractionBaseTable[3] = 524288;
        $FractionBaseTable[4] = 262144;
        $FractionBaseTable[5] = 131072;
        $FractionBaseTable[6] = 65536;
        $FractionBaseTable[7] = 32768;
        $FractionBaseTable[8] = 16384;
        $FractionBaseTable[9] = 8192;
        $FractionBaseTable[10] = 4096;
        $FractionBaseTable[11] = 2048;
        $FractionBaseTable[12] = 1024;
        $FractionBaseTable[13] = 512;
        $FractionBaseTable[14] = 256;
        $FractionBaseTable[15] = 128;
        $FractionBaseTable[16] = 64;
        $FractionBaseTable[17] = 32;
        $FractionBaseTable[18] = 16;
        $FractionBaseTable[19] = 8;
        $FractionBaseTable[20] = 4;
        $FractionBaseTable[21] = 2;
        $FractionBaseTable[22] = 1;
        $FractionBaseTable[23] = 0;

#Read the 4 bytes
        $b0 = $BinArr->[0];
        $b1 = $BinArr->[1];
        $b2 = $BinArr->[2];
        $b3 = $BinArr->[3];

		# Check to see if everything is clear, then output zero
		if (($b0|$b1|$b2|$b3) == 0)	{
			return 0.0;
		}

# Take the sign bit : 7th bit of b3
        $sign = $b3 & 0x80;

# Calculate the exponent now.
        $x = ($b3 << 8) | $b2;
        $exponent = ($x >> 7) & 0xFF;
        $mult = $exponent - 127;

#Calculate the non-exponent component
        $y = ($b2 << 16) | ($b1 << 8) | $b0;
        $z = $y & 0x7FFFFF;
        $fraction = $z << 1;
        $pattern = $fraction;
        $numerator = 0;
        for ($loop = 0; $loop < 23; $loop++)    {
                $bitset = ($pattern & 0x800000);
                if ($bitset)    {
                        $numerator += $FractionBaseTable[$loop];
                }
                $pattern = $pattern << 1;
        }
        $non_exponent = ($numerator / 8388608) + 1.0;
        $float = ($non_exponent) * 2 ** $mult;
        if ($sign)      {
                $float *= (-1);
        }
        return $float;
}

#####################################################################
# CalcTime()
# Input : Time value
# Output : Minutes, seconds, miliseconds
#####################################################################
sub CalcTime()	{
	$time = shift;

	$time =~ s/\+//;
	$min = int($time / 10000 / 60);
	$sec = ($time / 10000) % 60;
	$msec = sprintf("%03d", ($time % 10000) / 10);
	$str = $min.":".$sec.".".$msec;
	return $str;
}
 

#####################################################################
# crcCalculateBuffer()
# Input : 
# Output : 
#####################################################################
sub crcCalculateBuffer()
{
	my $byteOffset = shift;
	my $nByteCount = shift;
	my $crcValue = shift;
	my $cBufferPtr = shift;
	my ($crc, $crcPolynomial, $crcData, $i, $j, @crcTable);

	$crcPolynomial = 0xEDB88320;
	@crcTable = ();
	for ($i = 0; $i < 256; $i++) {
		$crc = $i;
		for ($j = 0; $j < 8; $j++) {
			if ($crc & 0x0001) {
				$crc = ($crc >> 1) ^ $crcPolynomial;
			}
			else {
				$crc = $crc >> 1;
			}
		}
		$crcTable[$i] = $crc;
	}
	#Calculate the new CRC here :-
	$crc = $crcValue;
	for ($i = 0; $i < $nByteCount; $i++) {
		$crcData = ($crc ^ $cBufferPtr->[$byteOffset + $i]) & 0xFF;
		$crc = (($crc >> 8) & 0x00FFFFFF) ^ $crcTable[$crcData];
	}
	return $crc;
}
